commit 58cd66aec9f87d742840b03206bacafbf0273a92
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Tue Sep 28 21:41:46 2021

    libstdc++: Fix return values for atomic wait on futex
    
    This fixes a logic error in the futex-based timed wait.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            * include/bits/atomic_timed_wait.h (__platform_wait_until_impl):
            Return false for ETIMEDOUT and true otherwise.
    
    (cherry picked from commit 2fcfc7d66862c67677f0e1c46391292d5a21a567)

diff --git a/libstdc++-v3/include/bits/atomic_timed_wait.h b/libstdc++-v3/include/bits/atomic_timed_wait.h
index 3db08f82707..d423a7af7c3 100644
--- a/libstdc++-v3/include/bits/atomic_timed_wait.h
+++ b/libstdc++-v3/include/bits/atomic_timed_wait.h
@@ -101,12 +101,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
 	if (__e)
 	  {
-	    if ((errno != ETIMEDOUT) && (errno != EINTR)
-		&& (errno != EAGAIN))
+	    if (errno == ETIMEDOUT)
+	      return false;
+	    if (errno != EINTR && errno != EAGAIN)
 	      __throw_system_error(errno);
-	    return true;
 	  }
-	return false;
+	return true;
       }
 
     // returns true if wait ended before timeout

